extensions [sound]
breed [wolves wolf]
breed [sheep a-sheep]
breed [lines line]
breed [players player]
breed [rants rant]
breed [bants bant]
breed [redqueen]
breed [bluequeen]

turtles-own [paint-color max-size age foraging-time ]
sheep-own [
  energy]
  ;paint-color]
wolves-own [wenergy]

patches-own [
  chemical             ;; amount of chemical on this patch
  chemicalblue
  chemicalkill         ;; attack pheremone
  chemicalload         ;; total amount of chemical on patch
  food                 ;; amount of food on this patch (0, 1, or 2)
  nest?                ;; true on nest patches, false elsewhere
  nest2?
  nest-scent
  nest2-scent           ;; number that is higher closer to the nest
  food-source-number   ;; number (1, 2, or 3) to identify the food sources]
]
rants-own [
  bodychemical-kill
  antergy
  killer?
 killoefficient]
bants-own [
  bodychemical-kill
  antergy
  killer?
  killoefficient]
globals [bluefood redfood diedbyage diedbystarvation diedbymurder reddiedbyage reddiedbystarvation reddiedbymurder]

to setup
  clear-all
  setup-patches
  set-default-shape rants "bug"
  set-default-shape redqueen "bug"
  set-default-shape bants "bug"
  
  if number-of-colonies > 0 [
  create-rants 10
  [ set size 1        ;; easier to see
    set color red 
    ;set paint-color green
    set antergy 200
    setxy red-colony-x red-colony-y
    if random 100 < murderer [set killoefficient 1 set shape "circle"]
    ]
  ]
  ;create-redqueen 1
 ; [set size 10
   ; set color red
   ; wiggle]
  
   if number-of-colonies > 1 [
  create-bants 10
 [set size 2
   set color blue
   ;set paint-color green
    setxy blue-colony-x blue-colony-y
    set antergy 200
    if random 100 < murderer [set killoefficient 1 set shape "circle" set size 10]]
   ]
   
  create-sheep 1
  create-wolves 2 [set wenergy 2000];; red = not carrying food
  ;setup-turtles
  reset-ticks
  ;set redfood  redfood + 10
  ask turtles [set age  1]
  output-type "attacking" output-type "," output-type "ticks" output-type "," output-type "who" output-type "," output-type "xcor" output-type "," output-type "ycor" output-type "," output-type "Foraging time" output-type "," output-type "age" output-type "," output-print "color"
end

to go
 ;; if ticks >= 500 [ stop] ; puts a time limit at 500 for simulation
  move-turtles              ;; moves the polinator agents
  ;ask rants bants [attack]
  ask rants                 ;;asks red ants, if they are not carrying food, to look for food, otherwise follow the nest-scent back to the nest along the way regardless wiigle, and if she's a murderer, attack other ants along the way, and move forward 1.
  [ ;if who >= ticks [ stop ] ;; delay initial departure
    ifelse color = red
    [ look-for-food  ]       ;; not carrying food? look for it
    [ return-to-nest ]       ;; carrying food? take it back to nest
    attack
    wiggle
    ifelse pcolor = black [fd 3]
    [fd 1]
    ] 
   ask bants [             ;;asks blue ants, if they are not carrying food, to look for food, otherwise follow the nest-scent back to the nest along the way regardless wiigle, and if she's a murderer, attack other ants along the way, and move forward 1
   ifelse color = blue
    [ look-for-food  ]       ;; not carrying food? look for it
    [ return-to-nest2 ]       ;; carrying food? take it back to nest
   attack
    wiggle
    ifelse pcolor = black [fd 3]
    [fd 1]
   ] 
  eat-grass                    ;; asks sheep to eat grass
  if count sheep < 1[reproduce] ;; if there aren't more than one sheep, make some more
  ;reproduce
  ask turtles [if size >= 4 [check-death]] ;; when ants have grown from size 2 to size 4 (matured) start checking death
  ;regrow-grass                           ;; randomly turns patches back to green
  ;;quarters                               ;; allows seasons to be set
  ;;if random 1000 > 800 [setup-patches]   ;; returns the beginning settings randomaly
  tick
 if random 1000 < 3 [diffusion]            ;; 3 out of 1000s of the time, divide patch color by eight and diffues it to neighbors
 diffusion-pheremone                       ;; slowly evaporate pheramone trails
 ask rants [if size < 3 [killer]]
  ask wolves [eat-turtle]                ;; asks wolves to eat sheep
  ;;colorset
 ask sheep [hide-turtle]                 ;; makes sheep and wolves invisible agents to represent their micro-size compaired to ants and plants.
 ask wolves [hide-turtle]
; ask turtles [hide-turtle]
 
  ;;ask sheep [play-map]
 birth                              ;; ask ant colony to reproduce
  grow                              ;; ask all ants to grow, if their size is less than 4 
  ask patches [recolor-patch2]
  ask turtles [set age age + 1]     ;; increment ant age by 1 each time step
  ;ask rants [output-type "rant" output-type "," output-type ticks output-type "," output-type who output-type "," output-type xcor output-type "," output-type ycor output-type "," output-type foraging-time output-type "," output-type age output-type ","output-print color] ;; outputs some demographics to the output window]
  ;ask bants [output-type "bant" output-type "," output-type ticks output-type "," output-type who output-type "," output-type xcor output-type "," output-type ycor output-type "," output-type foraging-time output-type "," output-type age output-type ","output-print color] ;; outputs some demographics to the output window]
  ;check-death
  
end

to move-turtles ; moves sheep and wolves randomly based on the wind directions ( movementx and movementy)
  ask sheep [
    right random 360
    ;;fd 1
    setxy xcor + movementx + random 10 ycor + movementy + random 10
  ]
  ask wolves [
    right random 360
   ; fd 1
   
    setxy xcor + random 10 ycor + random 10
    
  ]
  ask sheep [set energy energy - 2]
  ask wolves [set wenergy wenergy - 1]
  ;ask rants [set antergy antergy - 0.1]
end
  
  to move-lines
  ask lines [
    right 7
    ;;fd 1
    setxy xcor + xcor + 1  ycor + random 10
  ]
  end
    
    
  
  

to setup-patches
  ask patches [set pcolor green
   ifelse number-of-colonies = 1 [
     setup-nest red-colony-x red-colony-y
     recolor-patch2]
    
    [if number-of-colonies = 2[
      setup-nest red-colony-x red-colony-y
      setup-nest2 blue-colony-x blue-colony-y
      recolor-patch2
    ]  
    ]
    setup-food
    ;;recolor-patch
     ]
end



to setup-nest  [x y];; patch procedure
  ;; set nest? variable to true inside the nest, false elsewhere
  set nest? (distancexy x y ) < 5 
  ;set nest? (distancexy 25 25) < 5
  ;; spread a nest-scent over the whole world -- stronger near the nest
  set nest-scent 200 - distancexy x y
end

to setup-nest2 [x y] ;; patch procedure
  ;; set nest? variable to true inside the nest, false elsewhere
  set nest2? (distancexy x y) < 5
  ;; spread a nest-scent over the whole world -- stronger near the nest
  set nest2-scent 200 - distancexy x y
end

to setup-food  ;; patch procedure
  ;; setup food source one on the right
  if (distancexy (0.6 * max-pxcor) 0) < 5
  [ set food-source-number 1 ]
  ;; setup food source two on the lower-left
  if (distancexy (-0.6 * max-pxcor) (-0.6 * max-pycor)) < 5
  [ set food-source-number 2 ]
  ;; setup food source three on the upper-left
  if (distancexy (-0.8 * max-pxcor) (0.8 * max-pycor)) < 5
  [ set food-source-number 3 ]
  ;; set "food" at sources to either 1 or 2, randomly
  if food-source-number > 0
  [ set food one-of [1 2] ]
end

to setup-turtles
  
  create-sheep number [
    set size 2
    set energy 100
    set paint-color color
    
    
    ]
  create-wolves 200 [ set color black set size 4 set wenergy 100]
  ask turtles [setxy random-xcor random-ycor]
end

to create-line
  create-lines 1 [
    set size 2
    set energy 100
    set paint-color black
    
    
    ]
end

to color-chemical
  if show-chemicals? [
  if chemicalloadreport > 0 [set pcolor scale-color green chemicalloadreport 0.1 5]];; chemicalblue 0.1 5]] colors patches green scaled to the amount of chemcial on the patch
end

to-report chemicalloadreport ;; reports the total amount of chemical on a patch
  report chemical + chemicalblue + chemicalkill
end

to recolor-patch2  ;; patch procedure keeps the nest and three food patches a constant color
  ;; give color to nest and food sources
  color-chemical
  ;;ifelse chemical > 0 [set pcolor scale-color green chemical 0.1 5]
   ;;[if chemicalblue > 0.1 [set pcolor scale-color pink chemicalblue 0.1 5]
   ;;if chemicalkill > 0.1 [set pcolor scale-color pink chemicalblue 0.1 5]]
  if number-of-colonies > 0 [if nest? [ set pcolor violet]]
  if number-of-colonies > 1 [ifelse nest2?
  [ set pcolor yellow ]
  
   [if food > 0
    [ if food-source-number = 1 [ set pcolor sky ]
      if food-source-number = 2 [ set pcolor sky  ]
      if food-source-number = 3 [ set pcolor sky ] ]
    
    ;; scale color to show chemical concentration
     ;; pcolor scale-color green chemical 0.1 5];; set pcolor scale-color green chemical 0.1 5];; set pcolor scale-color red chemicalkill 0.1 5 ] 
   ]
  ]

end
to eat-grass ;eatting function for environmental agents sheep and wolves
  ask sheep [
     if pcolor = paint-color [
        set pcolor paint-color
       set energy energy + (energy-from-grass * 20)
       ] 
     if pcolor != black [
    if random 100 > 45 [
      set paint-color pcolor]
    set pcolor paint-color + random -5
    set chemical chemical + 15
    set energy (energy + energy-from-grass)
    ]
    ; if pcolor = white [ 
    ;set pcolor white + random 30
    ;set energy (energy + .01)
    ;] 
    ifelse show-food-preference?
    [set label energy]
    [set label ""]
  
      if pcolor = black [ 
    set pcolor black + random  10
    set energy (energy + energy-from-grass - 5)
    ]
     
  ]
  
  ask wolves [
    set pcolor black]
end

to reproduce ;reproduction of environmental agents sheep and wolves
  ask sheep [ 
    if energy > birth-energy [
      set energy energy - birth-energy
      hatch 1 [set energy birth-energy]
    ]
  ]
    ask wolves [ 
    if wenergy > birth-energy [
     set wenergy wenergy - birth-energy
      hatch 1 [set wenergy birth-energy]
  ]
 ]
end
  
  to check-death ; check to see if turtles will die, red ants lose no energy, blue ants lose 1 at every time step
      ask sheep [ 
         if energy <= 0 [die]
      ]
      ask wolves [ 
         if wenergy <= 0 [die]
      ]
       ask rants [ 
           set antergy antergy - 0.1 
         if antergy - (age / 1000) <= 0 [
           if antergy <= age / 1000[set reddiedbyage reddiedbyage + 1]
           if antergy <= 0 [set reddiedbystarvation reddiedbystarvation + 1] 
             die ]
         
      ]
        ask bants [
          set antergy antergy - 0.1 
         if antergy - (age / 1000) <= 0 [ 
           if antergy <= age / 1000 [set diedbyage diedbyage + 1]
           if antergy <= 0 [set diedbystarvation diedbystarvation + 1]
           die ]
         
      ]
        
  end
  
  to regrow-grass ; function to randomly regrow grass
    ask patches  [
      if random 10000 < regrowth [set pcolor green]
    ]
  end
  

  
  
  to eat-turtle ;wolves eat sheep
     let prey one-of sheep-here
if prey != nobody
  [ ask prey [ die ] set wenergy wenergy  + (random 100 / evaporationrate) ]
  
  
   
  end
  
 to diffusion
   
   diffuse pcolor diffusing
  ;; ask patches [set chemical chemical * (100 - evaporationrate)]
 end
 
 to colorset
   ask patches [ if chemical > 0 [
       set pcolor scale-color chemical 10 255 5]]
 end
 
 to play-map
   if sheep != nobody [
   ask turtles [sound:play-note "Choir Aahs" 60 + color  24 + paint-color pcolor / 50]]
 end
 
 ;; to play-map-patches
 ;;sort patches
 ;;let x patch -10 10

  ;; ask patch x y [sound:play-note-later 1 "Rain" pycor pxcor pcolor / 50]
 ;;  set x x - 1
   ;set y y - 1
 
 ;end
 
 to play
  let k 0
  while [k <= max-pxcor ] [
    ask patches with [ pxcor = k] [
    if (pcolor = green) [sound:play-note "SQUARE WAVE" (pycor * 4 + 25) 64 0.1 ]
    if (pcolor = black) [sound:play-note "SAWTOOTH WAVE" (pycor * 3 + 25) 64 0.1] ]
   ; ]
    set k (k + 1)
    wait 0.2
    ;;wait 2 / ( 5 + (count patches with [pxcor = k and state = 1]))
    ]
end
 
 to return-to-nest  ;; red ant procedure that when having food teach other ants food preferences while walking back to nest.
  tandum-running 
  ifelse nest?
  [ ;; drop food and head out again
    set color red
    set redfood redfood + foodbonus
    rt 180 ]
  [ set chemical chemical + 60  ;; drop some chemical
    uphill-nest-scent 
    ]         ;; head toward the greatest value of nest-scent
  
 
end

to return-to-nest2  ;; blue ant  procedure identical to red ants variety
  tandum-running
  ifelse nest2?
  [ ;; drop food and head out again
    set color blue
    rt 180 
    set bluefood bluefood + foodbonus]
  [ set chemicalblue chemicalblue + 60  ;; drop some chemical
    uphill-nest2-scent 
    ] 
end

to attack ;; If the current ant is a murderer, at every time step she selects an other ant on her patch and kills it. details: if the killoefficient is greater than zero (set by being a murderer at birth) at every time step select another turtle at the same spot, if that turtle is not a sheep polinator or a colony queen, ask the prey to die.
  if killoefficient > 0 [
  
  ;if breed = rants [
    let prey one-of other turtles-here
if prey != nobody [
  if [breed] of prey != sheep[
  if [breed] of prey != redqueen[
   ; output-type "attacking" output-type "," output-type ticks output-type "," output-type who output-type "," output-type xcor output-type "," output-type ycor output-type ","   output-type foraging-time output-type "," output-type age output-type "," output-print color
  if  1 <= killoefficient  [ set diedbymurder diedbymurder + 1 ask prey [ die ]  ] ] ] ]];]

  ;;if one-of turtles-here != self[
  ;let prey one-of turtles-here
  
 
;if prey != nobody [
  ;if 1.00 <= killer-coefficient +  coegressive + bluegressive + regressive + killoefficient [ask prey [ die ]] 
    ; set bodychemical-kill bodychemical-kill * (100 - evaporation-rate) / 100]]
  
  ;;let location patch-here
  ;;set chemicalkill chemicalkill + 15]
end

to attack2
 ; if killer? = true [
  ;  print "killer"
  let prey one-of rants-here
 ;; if breed != rants [
if prey != nobody [
  ask prey [ die ] 
     set bodychemical-kill bodychemical-kill * (100 - evaporation-rate) / 100]
  
  ;;let location patch-here
  ;;set chemicalkill chemicalkill + 15]
end



to look-for-food  ;; turtle procedure teaches other turtles with tandum running, then checks if the current patch is a shade of the prefered food patch, if so set energy +250, if not, and the patch isn't black, 10% of the time, change preferences and set food + 20, then go right 180 degrees, and head for the nest.
  ;tandum-running
  set foraging-time foraging-time + 1
  if pcolor != 115 and pcolor != 45 [
  if [shade-of? brown pcolor] of patch-here = false[
    
    
  if shade-of? pcolor paint-color 
   [ set color orange + 1
    set paint-color pcolor     ;; pick up food
    set food food - 1      ;; and reduce the food source
    set pcolor brown
    set antergy antergy + 250        
    rt 180                   ;; and turn around
    stop 
    ]
]
  ]
  ;; go in the direction where the chemical smell is strongest
  
  
  if random 1000 < 1 
  [ if shade-of? pcolor brown = false and pcolor != 115 and pcolor != 45 [
    set color orange + 1
    set paint-color pcolor     ;; pick up food
    set food food - 1        ;; and reduce the food source
    set pcolor brown
    set antergy antergy + 20  
    rt 180                   ;; and turn around
    stop 
    ]]
  ;; go in the direction where the chemical smell is strongest
  if (chemical >= 0.05) ;and (chemical < 2)
  [ uphill-chemical ]
end



;; sniff left and right, and go where the strongest smell is
to uphill-chemical  ;; turtle procedure
  let scent-ahead chemical-scent-at-angle   0
  let scent-right chemical-scent-at-angle  45
  let scent-left  chemical-scent-at-angle -45
  if (scent-right > scent-ahead) or (scent-left > scent-ahead)
  [ ifelse scent-right > scent-left
    [ rt 45 ]
    [ lt 45 ] ]
end

to uphill-chemical2  ;; turtle procedure
  let scent-ahead chemicalblue-scent-at-angle   0
  let scent-right chemicalblue-scent-at-angle  45
  let scent-left  chemicalblue-scent-at-angle -45
  if (scent-right > scent-ahead) or (scent-left > scent-ahead)
  [ ifelse scent-right > scent-left
    [ rt 45 ]
    [ lt 45 ] ]
end


;; sniff left and right, and go where the strongest smell is
to uphill-nest-scent  ;; turtle procedure
  let scent-ahead nest-scent-at-angle   0
  let scent-right nest-scent-at-angle  45
  let scent-left  nest-scent-at-angle -45
  if (scent-right > scent-ahead) or (scent-left > scent-ahead)
  [ ifelse scent-right > scent-left
    [ rt 45 ]
    [ lt 45 ] ]
end

;; sniff left and right, and go where the strongest smell is
to uphill-nest2-scent  ;; turtle procedure
  let scent-ahead nest2-scent-at-angle   0
  let scent-right nest2-scent-at-angle  45
  let scent-left  nest2-scent-at-angle -45
  if (scent-right > scent-ahead) or (scent-left > scent-ahead)
  [ ifelse scent-right > scent-left
    [ rt 45 ]
    [ lt 45 ] ]
end



to wiggle  ;; turtle procedure which randomly moves ants
  rt random 40
  lt random 40
  if not can-move? 1 [ rt 180 ]
end

  
  to birth ;; creates an an with m probility rate of being a murderer if colony food is greater than 200
    
 if redfood > 200 [
       set redfood redfood - 200
      create-rants 1 
    [setxy red-colony-x red-colony-y ;set paint-color green
      set antergy 2000
       if random 100 < murderer [set killoefficient 1 set shape "circle" set size 8 set antergy 2000]
       ;if random 10000 > count rants [print "yes"]
       ] 
 ]
 
  if bluefood > 200 [
    set bluefood bluefood - 200
    create-bants 1 
    [setxy blue-colony-x blue-colony-y ;set paint-color green
      set antergy 2000
        if random 100 < murderer [set killoefficient 1 set shape "circle" set size 8 set antergy 2000]]
        
  ]
  
   
   
    
    
    ;ask redqueen [hatch-rants 1 
     ; [setxy 0 0
      ;   set size .1 
       ;  set antergy 200 
        ; if random 100 < 1 [set killoefficient 1 
         ;  set shape "circle"]
         ;]] ;;set killer? true
   ;set redfood redfood - 200]
  ;;setxy bluestart bluestart]
  
end
  
  to killer
    if random 100 > 1 [set killer? true]
  end


to-report nest-scent-at-angle [angle] ; reports the amount of pheramone in a certain direction
  let p patch-right-and-ahead angle 1
  if p = nobody [ report 0 ]
  report [nest-scent] of p
end

to-report chemical-scent-at-angle [angle] ; reports the amount of pheramone in a certain direction
  let p patch-right-and-ahead angle 1
  if p = nobody [ report 0 ]
  report [chemical] of p
end

to-report nest2-scent-at-angle [angle] ;reports the amount of blues nest scent in a certain direction
  let p patch-right-and-ahead angle 1
  if p = nobody [ report 0 ]
  report [nest2-scent] of p
end

to-report chemicalblue-scent-at-angle [angle] ; reports the amount of pheramone in a certain direction
  let p patch-right-and-ahead angle 1
  if p = nobody [ report 0 ]
  report [chemicalblue] of p
end


to-report antattachpheremones
  let antattachpheremone bodychemical-kill
  report antattachpheremone
end

to diffusion-pheremone
  diffuse chemical (diffusing / 100)
  ask patches
  [ set chemical chemical * (100 - evaporation-rate) / 100]  ;; slowly evaporate chemical
    ;recolor-patch2 ;]
end

to diffusion-pheremone2
  diffuse chemicalblue (diffusing / 100)
  ask patches
  [ set chemicalblue chemicalblue * (100 - evaporation-rate) / 100]  ;; slowly evaporate chemical
    ;recolor-patch2 ;]
end



  
  to grow ; if size is less than 4, increment size by .05%, elsewise keep the size 4
    ask turtles [ifelse size < 4 [set size size * 1.005 ]
      [set size 4]]
  end
  
  to tandum-running ; check if the other ant is not grown (below size 6) and if so teach her the adults food finding preference
    
    let student one-of other turtles-here
    if student != nobody [
       
      if [breed] of student = breed [
            ;output-type "teaching" output-type "," output-type ticks output-type "," output-type who output-type "," output-type xcor output-type "," output-type ycor output-type "," output-type foraging-time output-type "," output-type age output-type ","output-print color ;; outputs some demographics to the output window
    ask student [set paint-color [paint-color] of myself]] ]
    ;if any? rants with [size < 6 or paint-color != paint-color]
 ; [if size >= 6 [set paint-color paint-color]]
  
  
  
 ;if any? rants with [antergy < 10]
  ;[if antergy > 10 [set antergy antergy + 10]
    ifelse show-food-preference?
    [set label round paint-color]
   [set label ""]
  end
  
  
  
    

     
     to-report bluefoods ;reports the current colony food
       report bluefood
     end
       
  to-report redfoods ;reports the current colony food
       report redfood
     end
  
  to-report redforagingtime ;; provides the average foraging time of red ants at each time step. sums the foraging time of all red ants, and then divides the sum by the number of red ants
   
   report sum [foraging-time] of rants   / count rants
 
  end
  
  to-report blueforagingtime ;; provides the average foraging time of blue ants at each time step. sums the foraging time of all blue ants, and then divides the sum by the number of blue ants
   
   report sum [foraging-time] of bants / count bants
  
  end
  
  
       to-report redage ;; provides the average age of red ants at each time step. sums the age of all red ants, and then divides the sum by the number of red ants
         
   report sum [age] of rants / count rants
         
  end
  
  to-report blueage ;; provides the average age of blue ants at each time step. sums the age of all blue ants, and then divides the sum by the number of blue ants
   
   report sum [age] of bants / count bants
   
  end
  
  to-report rantfoodpreference
    
  
  report  modes [paint-color] of rants; with [paint-color != 55]
  end
  
  to-report mostavailablefood
     
  report   modes [pcolor] of patches with [pcolor != black and pcolor != sky and pcolor != violet and pcolor != yellow]
  end
  
  to-report stdrantfoodpref
    report standard-deviation [paint-color] of rants
  end
  
  to-report stdbantfoodpref
    report standard-deviation [paint-color] of bants
  end
  
  
 to-report bantfoodpreference
    
  
  report  modes [paint-color] of bants
  end
 
 to-report agedeaths
   report diedbyage
 end
  
  to-report fooddeaths
    report diedbystarvation
  end
  
  to-report murders
    report diedbymurder
  end
  
  to-report redagedeaths
   report reddiedbyage
 end
  
  to-report redfooddeaths
    report reddiedbystarvation
  end
  
  to-report redmurders
    report reddiedbymurder
  end
  
  to-report %bluemurderer
    report count bants with [shape = "circle"]
  end
  
  to-report %redmurderer
    report count rants with [shape = "circle"]
  end
  

; Copyright 1997 Uri Wilensky.
; See Info tab for full copyright and license.

 
 
 
  
  
  
    




  
@#$#@#$#@
GRAPHICS-WINDOW
722
155
1093
547
50
50
3.5743
1
10
1
1
1
0
1
1
1
-50
50
-50
50
1
1
1
ticks
30.0

BUTTON
27
10
93
43
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
95
10
158
43
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
514
10
620
55
% open ground
(count patches with [shade-of? pcolor brown] / count patches ) * 100
2
1
11

SWITCH
1093
89
1297
122
show-food-preference?
show-food-preference?
1
1
-1000

SLIDER
1089
15
1261
48
number
number
0
200
200
1
1
NIL
HORIZONTAL

SLIDER
726
729
900
762
energy-from-grass
energy-from-grass
0
100
10
1
1
NIL
HORIZONTAL

SLIDER
908
732
1080
765
birth-energy
birth-energy
0
100
100
1
1
NIL
HORIZONTAL

SLIDER
1298
15
1470
48
regrowth
regrowth
0
100
28
1
1
NIL
HORIZONTAL

SLIDER
1090
732
1262
765
regrow
regrow
0
1000
50
1
1
NIL
HORIZONTAL

SLIDER
1489
15
1661
48
movementx
movementx
-10
10
-10
.5
1
NIL
HORIZONTAL

SLIDER
1492
53
1664
86
movementy
movementy
-10
10
10
.5
1
NIL
HORIZONTAL

SLIDER
1300
89
1472
122
diffusing
diffusing
0
1
0.18
.01
1
NIL
HORIZONTAL

SLIDER
1299
52
1471
85
evaporation-rate
evaporation-rate
0
100
100
1
1
NIL
HORIZONTAL

MONITOR
165
15
234
60
Red Ants
count rants
17
1
11

MONITOR
235
10
352
55
Red's Food store
redfood
17
1
11

MONITOR
355
10
426
55
Blue Ants
count bants
17
1
11

MONITOR
429
10
510
55
Blues' food
bluefood
17
1
11

SWITCH
915
53
1078
86
show-chemicals?
show-chemicals?
1
1
-1000

SLIDER
42
695
214
728
evaporationrate
evaporationrate
0
100
50
1
1
NIL
HORIZONTAL

SLIDER
915
93
1087
126
murderer
murderer
0
100
0
.01
1
NIL
HORIZONTAL

PLOT
1362
133
1761
401
plot 1
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"Red Murderers" 1.0 0 -1069655 true "" "plot count rants with [shape = \"circle\" ]"
"Blue Ants" 1.0 0 -13345367 true "" "plot count bants"
"Red Ants" 1.0 0 -2674135 true "" "plot count rants"
"blue Murderers" 1.0 0 -8275240 true "" "plot count bants with [shape = \"circle\"]"

SLIDER
915
15
1087
48
foodbonus
foodbonus
0
200
15
1
1
NIL
HORIZONTAL

OUTPUT
1308
642
1508
833
5

PLOT
19
53
708
443
Red food preferences
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"Red ants that like red food" 1.0 1 -5298144 true "" "plot count rants with [shade-of? paint-color red]"
"Red ants that like orange food" 1.0 0 -955883 true "" "plot count rants with [shade-of? paint-color orange ]"
"Red ants that like brown food" 1.0 0 -6459832 true "" "plot count rants with [shade-of? paint-color brown ]"
"Red ants that like yellow food" 1.0 0 -1184463 true "" "plot count rants with [shade-of? paint-color yellow]"
"Red ants that like green food" 1.0 0 -10899396 true "" "plot count rants with [shade-of? paint-color green]"
"Red ants that like lime  food" 1.0 0 -13840069 true "" "plot count rants with [shade-of? paint-color lime]"
"Red ants that like turquoise food" 1.0 0 -14835848 true "" "plot count rants with [shade-of? paint-color turquois]"
"Red ants that like cyan food" 1.0 0 -11221820 true "" "plot count rants with [shade-of? paint-color cyan]"
"Red ants that like sky food" 1.0 0 -13791810 true "" "plot count rants with [shade-of? paint-color cyan]"
"Red ants that like violet food" 1.0 0 -8630108 true "" "plot count rants with [shade-of? paint-color violet]"
"Red ants that like Magenta food" 1.0 0 -5825686 true "" "plot count rants with [shade-of? paint-color magenta]"
"Red ants like blue food" 1.0 0 -13345367 true "" "plot count rants with [shade-of? paint-color blue]"
"Red ants the like pink food" 1.0 0 -2064490 true "" "plot count rants with [shade-of? paint-color pink]"
"Red ants that like gray food" 1.0 0 -7500403 true "" "plot count rants with [shade-of? paint-color gray]"
"Red ants that like white food" 1.0 0 -16777216 true "" "plot count rants with [paint-color = 9.9 or paint-color = 19.9 or paint-color = 29.9 or paint-color = 39.9 or paint-color = 49.9 or paint-color = 59.9 or paint-color = 69.9 or paint-color = 79.9 or paint-color = 89.9 or paint-color = 99.9 or paint-color = 109.9 or paint-color = 119.9 or  paint-color = 129.9 or paint-color = 139.9]"

SLIDER
1090
52
1270
85
number-of-colonies
number-of-colonies
0
2
2
1
1
NIL
HORIZONTAL

INPUTBOX
732
82
887
142
Red-colony-x
0
1
0
Number

INPUTBOX
825
82
906
143
red-colony-y
0
1
0
Number

INPUTBOX
735
15
821
77
blue-colony-x
7
1
0
Number

INPUTBOX
825
15
907
75
blue-colony-y
25
1
0
Number

PLOT
19
449
717
751
Patches of Color
NIL
NIL
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -7500403 true "" "plot count patches with [shade-of? pcolor gray]"
"pen-1" 1.0 0 -2674135 true "" "plot count patches with [shade-of? pcolor red]"
"pen-2" 1.0 0 -955883 true "" "plot count patches with [shade-of? pcolor orange]"
"pen-3" 1.0 0 -6459832 true "" "plot count patches with [shade-of? pcolor brown]"
"pen-4" 1.0 0 -1184463 true "" "plot count patches with [shade-of? pcolor yellow]"
"pen-5" 1.0 0 -10899396 true "" "plot count patches with [shade-of? pcolor green]"
"pen-6" 1.0 0 -13840069 true "" "plot count patches with [shade-of? pcolor lime]"
"pen-7" 1.0 0 -14835848 true "" "plot count patches with [shade-of? pcolor turquoise]"
"pen-8" 1.0 0 -11221820 true "" "plot count patches with [shade-of? pcolor cyan]"
"pen-9" 1.0 0 -13791810 true "" "plot count patches with [shade-of? pcolor sky]"
"pen-10" 1.0 0 -13345367 true "" "plot count patches with [shade-of? pcolor blue]"
"pen-11" 1.0 0 -8630108 true "" "plot count patches with [shade-of? pcolor violet]"
"pen-12" 1.0 0 -5825686 true "" "plot count patches with [shade-of? pcolor magenta]"
"pen-13" 1.0 0 -2064490 true "" "plot count patches with [shade-of? pcolor pink]"

@#$#@#$#@
Purpose
To show the population function of two ants colonies, each of which has a proportion of members that cannot differentiate friend from foe, in competition with each other,  we built a simulation using Netlogo 5.0.5. (Wilensky, 1999), to highlight where such conflicts are most likely to occur, and their effect on emergent properties of population: foraging efficiency and resilience in times of crisis.

Entities, state variables, and scales
Our model contains four entity types: ants, sheep, wolves and patches, which are map squares in Netlogo terminology. These entities interact as follows: sheep and wolves are environmental background actors which create an environmental equilibrium, ants harvest from these environs, all agents communicate with each other by the fact they all change the colors of the models environment. 

In the model, two collectives, red ants (rants) and blue ants (bants), live on a very small sphere, using the pheromone trail laying mechanism outlined previously by Wilensky (1997). The two colonies start out the simulation with a built in dietary preference  paint-color, this variable is always a number between 0 and 139.9, corresponding to Netlogo’s built in color pallete. When an ant finds a patch that corresponds to her paint-color she picks it up and gains some energy, 250 antergy. She then turns the patch black and returns some colony food (bluefood or redfood) to the home nest (return-to-nest).  When the collective reaches 200 food (global variables redfood or bluefood), it hatches a new baby ant using the birth function. The ant slowly grows (grow), by 1.001 times its current size each step, until it reaches size 4. Because birth can only at max hatch one ant per colony per step, the max growth rate equals steps. Ants also have variables age, their current x and y coordinates and a state of whether they are looking-for-food or returning-to-nest and the time-spent-foraging: the number of steps they have spent looking-for-food. Ant collectives also own killoefficient, which if equal to 1 means the ant kills every other ant they contact using the attack function. If not, the ant never attacks.

We created a function for mortality based on age. At every time step, ants lose energy (antergy) and age, if the antergy minus age / 1000 ever falls below 0, the ant dies (check-death). In general, we did not use the function, as death by mortality confounds results which show that murder rate results in colony collapse. Further. the time scale of our simulations was approximately 4 hours, so natural mortality was not applicable. Consequently, unless noted scenario findings in the results do not implement the check-death function.

Changing ecosystem
Ants occupy rapidly oscillating ecosystems (Vasconcelos, 2008). The simulation represents this situation using three agent sets, sheep, wolves and patches. There is a pollinator agent  (sheep), who pick up patches’ pcolor and place patches which transmits errors in the patch-map color every time step. patches have the variable paint-color which stores a number between 0 and 139.9, which corresponds to Netlogo’s color pallet. They also have winds which increment their speed in the prevailing winds direction, set by variables movementx, and movementy which are set between -10 and 10 and move sheep that many patches in each step. Patches are set to 4 pixels, which is the same size as a fully grown ant, so patches are one ‘antomole’ squared, if ant length is taken as a unit of measure.

Patches use the diffuse primitive to pass their color (pcolor) to neighboring 8 patches to simulate growth of plant life. This simulates the environmental changes through time ant colonies are subject to. This means the environment is an equilibrium of the total number of patches disseminating color and sheep  pollinators picking up and dropping seeds around the tiny sphere. As a result, the map coloration is mostly stable but can have cessation of colors due to stochastic distributions, leading to new distributions simulating climactic changes in an agent based framework. Patches also store chemical, pheromones that lead back from food, and the nest scent. Nest scent is a value between the nests location and max xcor and and ycor. Ants use this to return to the nest. Furthermore, some patches have the boolean variable nest? (rant colony location) nest2? (bant colony location] or foodpatch. The affected patches are declared by setup-patches function. 

The model contains wolves as an agent set. They eat sheep, and when they touch a patch set it to black (0), which makes it inedible to ant collectives. They have a x and y coordinate, and wolf energy, wenergy. They move a user defined amount each time step and on contact eat sheep. They are modelled as a blight on the environment, or a predator.

time
Each step in the model is the time taken by one ant to travel a distance equal to its body length (approximately one second). Our longest simulations ran for 16,0000 steps, or approximately 4.5 hours if translated to reality.

Process overview and scheduling
The model functions in the following order every time step: move-turtles moves the sheep and wolves. Ask rants, if they are not carrying food, to look-for-food, otherwise return the food they are carrying to the nest. If they are carrying food and they meet a smaller ant, share their successful foraging strategy with that ant using tandum-running. The whole time, attack ants they meet, wiggle and move forward one patch. After the red ants, ask the blue ants to do the same things in the same order. Then ask the pollinators to eat-grass. At this point if mortality is turned on check all agents energy levels and if too low, kill off the pertinent ants. Then check if 1000 < 3 and if so ask all the plants to spread to their neighboring cells using diffuse primitive. Deteriorate pheromone trails with  diffusion-pheremone. Then reproduce ants using birth, grow, and finally ants age by 1 each step.

Emergence
Our model extends the emergent behavior of ants presented in Wilensky (1997). Our model has three distinct additions: the landscape distribution, the growing ant population, and the effect of ants attacking. 

1.	The landscape emerges through the use agents make of it. Regardless of the starting arrangement of colors, the number and direction of agents’ action alters the landscape, creating an ever changing cascade of landscape, due to the interactions of the agents with the landscape;
2.	The ant population is a function of how well their population adapts to the changing ecosystem. At the same time, it also depends on how the ants affect the ecosystem. The stochastic interaction between ants and their environment therefore shapes both the colony populations and the environment; and
3.	The number of murderers in the ant population drastically affects the ant population, while the population is a function of the dynamic distribution of resources within the environment and the colony learning. The effect of murders, though consistent on average (i.e., over several runs of the simulation), is still an emergent outcome.

There are several non-emergent functions. Ants all have a preset starting location and energy level. Colonies have a preset, 200 food, threshold to produce another ant. The total number of environmental agents is capped (mostly for performance reasons, 100,000 agents definitely bogs the computer down). These elements create an easier to analyze though less ‘realistic’ simulation. Because the simulation only models hours of interaction, we took these interactions as ‘snapshots’ to talk about generational change.
Adaptation
Agents (ants) constantly adapt to their local environment. Ants in our model learn locally. They constantly check the color of the patch they are on, and based on thresholds, they act on their local patch. Their actions towards patches include taking on the color of the patch they are on, changing the color of the patch they are on, or stripping the patch of color. Their actions towards other agents include teaching, learning or attacking. Because they are rewarded for finding patches of their preferences, success in the simulation depends on the adaptive success of their food preferences. Over time, they adapt to local prevalent colors, but through depletion often exhaust those local resources and are forced to adopt new preferences through local interaction.
Objectives
Agents in our model use a reproduction function based on gaining enough energy to surpass a built in threshold and reproduce. Environmental agents reproduce locally, ants reproduce at the colony, as the workers are sterile. Patches too reproduce, but they do it using the diffuse primitive, if nothing eats them they simply grow to their neighboring 8 patches. Thus, agents objective is to maximize their population, and patches objective is to maximize their colors screen space. 
Learning
Agents in our system learn food preferences through interaction with patches. They get more reward for finding patches of the color they previously prefered, but they can learn new preferences.
Prediction
Agents only make local decisions, they have no ability to predict. Everything is locally contextual.

Sensing
Ants can sense the local optimum food preference based on taking on the preferences of successful foragers they encounter. This local optimum passes through the colony like a game of telephone, until that food color is exhausted. Additionally, ants can sense the amount of pheromone laid on the patch they are on and move towards the patch with the highest pheromone load in their forward 45 degree arch.
Interactions

Dietary Preference changing
Ants can improve performance due to a function of memory and information sharing (Landridge et al, 2004). In fact these preferences changing and the impact of selection on successful foraging preferences may be part of the emergence of castes in ants (Oster and Wilson, 1978). For a software agent, to deal with a changing world, means that they must do more than have parameters, they must change parameters to fit novel arrangements. With this machine learning paradigm in mind and building off Holland (1976) and Lanzi’s work (2000), we derived a simple genetic algorithm (GA) to simulate these changing preferences. The GA follows Lanzi: 
For an agent interacting with a physical environment, learning is going to be not only a matter of optimally tuning a set of parameters, but also of discovering structure. An optimal structure of the environment is somehow mirrored by the structure of the agent's representation of its own behavior.
(2000, pp 11).
The ‘somehow’ mirroring, is accomplished by creating a dietary preference equilibrium through random attempts, and social learning. We increased reward through habit giving the individual ant more energy if it eats food a shade of its prefered food, for every time step t an ant does not find food of its preference (paint-color), she has a chance (1 in 10,0000) of changing her preference and eating the color of the patch she is standing on. She then sets her paint-color to the color of the patch she’s on and gains 20 antergy. When she finds subsequent food of her preference, she’ll gain 250 antergy.  Furthermore, ants in the colony share their preferences. 

When adult ants who are returning food to the nest meet baby ants, they set the young’s foraging preferences to their own (tandum-running). As a result, the ants are capable of foraging in an ever-changing environment adapting and sharing their successful preferences to take advantage of ephemeral resources. Of course, the ants preferences at any time only represent local optima, as they exploit the area nearest their nest most completely (Azzag, 2003). The machine learning, social learning and stochastic random trials allows the society to adapt to find food in an ever changing environment. The model could be extended to include phenotypic instead of just behavioral evolution by varying antergy and global colony food gains when innate in variables are met: like ants with long mandible harvest flowers better.

Pollinator Plant
Furthermore, plant patches succeed by spreading their information across the map. This spread is a two part interaction, they spread locally themselves, through seed dissemination, but pollinator sheep also carry their information across the map where they seed it, allowing for dissemination of plant life throughout the map.

Intraspecific Competition
To model the fact that some hymenoptera kill their nest-mates, and to abstract away the reason, there is a murderer rate (m) applied to every ant at birth. If m is 1 then 1% of ants born kill other ants when they contact them (attack).  If m is 100, then every ant kills every ant it contacts, creating a total state of nature. This rate models the frequency with which ants in our colonies cannot recognize their nestmates, or in other words, errors in the hydrocarbon identification system. This behavior in our ants simulation could be compared to some deviant behavior in humans (Clinard, et al., 2010).

Stochasticity
The simulation handles key processes stochastically: the emergence of murderers, plant growth, environmental agent’s movement, food rewards, random discovery walks, and food preference changing. Stochasticity is used in these processes to allow events to occur at frequencies rather than at times, or to add variability in the agents’ direction of movement. In either case, we employed stochastic thresholds when the outcome did not matter at the local level, as it is the aggregate effect that we sought to study.

Collectives
The agents form collectives. Both colors of ant are collectives, as are the sheep, wolves and patch colors. Collectives of agents are declared as a separate breeds. Patches become collectives through the prevalence of that color on the map. The breeds of ants are bound together through collective foraging and reproduction, as well as parameter passing of food preferences. The sheep take collective action because they all are moved by the wind’s speed and direction, set by global variables movementx and movementy. The wolves are only a collective in the fact they are a breed, besides that they each act rather independently. The ant colonies, due to their shared reproduction and foraging become a sort of organism made of individual ants. Likewise, the plant life becomes a rainbow of collectives as the shades disseminate over the map.

Observation
The data collected includes the population, the average age, average time spent foraging and total collected food of each ant colony. These measures are collected at each time step. Additional information, the x and y coordinates of interactions such as teach and attack, was also observed.

Initialization
The colonies of ants are set up at 0, 0 and 10,10. Each colony is given ten worker ants. There is 1 sheep on the map to start. There are no wolves unless added as an intervention. Each ant starts with 200 food and a percent chance (random 100 > murderer) of starting as a  murderer. The ants are given a food preference depending on the scenario: green, nothing, or random 139.9. the evaporation rate of pheromone trails is set to 0.11. The wind is set to 0 x and 10 y. The food bonus is set experimentally between 1 and 200. The sphere of play arena, is set to 50 by 50 or 150 by 150 patches. The murderer rate is set between 0-100. Patches are set to four pixels. The energy reward for finding an ants prefered food is 250. The energy for learning a new food preference is 20.

Submodels
move-turtles
To move environmental actors based on wind speed plus their own speed, environment plus personal inclination, we implemented this code:

move sheep and wolves randomly based on the wind directions ( global variables movementx and movementy): reset the sheeps x location by movementx plus a random number between 1 and 10. Then reset their y location by movementy plus a random number between 1 and 10. 

This moves the sheep based on the screens pixels, instead of patches. Patches are at the ant scale and environmental factors are of a smaller scale, we assume. 

Afterward set wolves a random 10 x and y from where they are.  
finally, decrement ants’ energy by 2 and wolves’ by 1. 

This procedure was designed to create a scale of action below the ant scale that builds the environment but does not interact much with the ants’ scale.
look-for-food
To get ants to forage for food if they have not found any yet we implemented this code:

To account for the time ants spend foraging in their life every ant owns their own foraging-time variable.
At ever time step they are searching, it is incremented by 1.

At every time step, ants check the color of the patch they are standing on, if it is not the red nest, blue nest or a black patch they implement the food collection code:

If the color of the patch they are on is a shade of their food preference color, paint-color, 
pick up that food, 
deplete the patch to black, 
gain 250 personal energy and return the foraged food to the nest by following the nest scent. 

Now there may be times an ant cannot find food of its prefered shade. In that case, one step in 10,000, the ant will experiment with a new food source:

If the patch an ant is on is not the red or blue nest, or a black depleted patch,
set that ant’s preference to the patch it is on, 
gain a reduced reward of just 20 personal energy, we assume trying new things is hard. Deplete that patch to black. 
Then the ant turns and follows the nest scent back to its colony to deposit its foraged food.

tandum-running
when returning food to the nest for colonial consumption ants teach colony-mates their successful foraging preferences as follows:

pick another ant on the same patch, if that ant is the same breed as ourself,
set the paint-color of the student to our own immediately.

Ants teach foraging habits and behaviours to other ants by walking along together. By this method ants learn to forage, avoid predators and other useful techniques (Franks and Richardson, 2006). The idea of tandum-running creates the situation where learning has a time cost. One design extension would be to add a coefficient to represent the time cost of learning and study how that would impact fitness.

attack
Ants sometimes are aggressive (Moffette 2012). Our study looks at what happens to an an colony when the function that identifies friend from foe is turned off for a proportion of a colony. To implement this behavior we use the following code:

If the current ant is a murderer,
if the killoefficient is greater than zero (set at birth by murderer rate) select another turtle at the same spot, 
If that turtle is not a sheep, ask the turtle to die.

This function is rather extreme, it removes most targetting for violence. If ants have a killoefficent, they simply kill every ant they encounter. Such black and white behavior is highly improbably in nature, but we wanted to demonstrate the effect of behavior as starkly as possible. Finding the actual parameters of such behavior would be done in field or lab experiments for suitable species of ants.

Related Model: Wilensky, U. (1997). NetLogo Ants model. http://ccl.northwestern.edu/netlogo/models/Ants. Center for Connected Learning and Computer-Based Modeling, Northwestern University, Evanston, IL.

Built by Kit Martin 2014
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.1.0
@#$#@#$#@
@#$#@#$#@
1.0
    org.nlogo.sdm.gui.AggregateDrawing 2
        org.nlogo.sdm.gui.StockFigure "attributes" "attributes" 1 "FillColor" "Color" 225 225 182 102 82 60 40
            org.nlogo.sdm.gui.WrappedStock "" "" 0
        org.nlogo.sdm.gui.ConverterFigure "attributes" "attributes" 1 "FillColor" "Color" 130 188 183 231 81 50 50
            org.nlogo.sdm.gui.WrappedConverter "" ""
@#$#@#$#@
<experiments>
  <experiment name="experiment 200 x food bonus, .64% intra-competition" repetitions="100" runMetricsEveryStep="false">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="30000"/>
    <metric>count bants</metric>
    <metric>count rants</metric>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="14"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="0.64"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment" repetitions="100" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="2000"/>
    <metric>count bants</metric>
    <metric>count rants</metric>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="14"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="5.06"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="2000"/>
    <metric>count bants</metric>
    <metric>count rants</metric>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="14"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment 1% murder rate" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="2000"/>
    <metric>count bants</metric>
    <metric>count rants</metric>
    <enumeratedValueSet variable="bluestart">
      <value value="14"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment 100% murder rate" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="2000"/>
    <metric>count bants</metric>
    <metric>count rants</metric>
    <enumeratedValueSet variable="bluestart">
      <value value="14"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment 50% murder rate" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="2000"/>
    <metric>count bants</metric>
    <metric>count rants</metric>
    <enumeratedValueSet variable="bluestart">
      <value value="14"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment-100x-food-bonus" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="2000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="14"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="foodbonus">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment Blue colony does not kill, located max-pcor from red" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="3000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <metric>count turtles</metric>
    <enumeratedValueSet variable="foodbonus">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="45"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment Blue colony does not kill, located 10 patches from red" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="3000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <metric>count turtles</metric>
    <enumeratedValueSet variable="foodbonus">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment both colonies, located10 from red" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="3000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <enumeratedValueSet variable="foodbonus">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment both colonies kill, located 10 patches from red food bonus times 50" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="3000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <enumeratedValueSet variable="foodbonus">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment Blue colony does not kill, located 10 patches from red food bonus times 50" repetitions="10" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <timeLimit steps="3000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <enumeratedValueSet variable="foodbonus">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="-3"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="murderer">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment" repetitions="2" runMetricsEveryStep="true">
    <setup>setup
create-sheep 500</setup>
    <go>go</go>
    <timeLimit steps="2000"/>
    <metric>count bants</metric>
    <metric>count rants</metric>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
    <steppedValueSet variable="murderer" first="10" step="30" last="100"/>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="foodbonus">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="94"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="experiment bot colonies learn kill 0-10 m 6000 steps 5 reps" repetitions="5" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <final>export-output "competition"</final>
    <timeLimit steps="6000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <enumeratedValueSet variable="foodbonus">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <steppedValueSet variable="murderer" first="0" step="10" last="100"/>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Impact of learning" repetitions="4" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go
if ticks = 10000 [set redfood 0 set bluefood 0]</go>
    <timeLimit steps="16000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <metric>redfoods</metric>
    <metric>bluefoods</metric>
    <metric>redforagingtime</metric>
    <metric>blueforagingtime</metric>
    <enumeratedValueSet variable="murderer">
      <value value="20"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="foodbonus">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Impact of learning age and foraging time measured" repetitions="16" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go
if ticks = 10000 [set redfood 0 set bluefood 0]</go>
    <timeLimit steps="16000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <metric>redfoods</metric>
    <metric>bluefoods</metric>
    <metric>redforagingtime</metric>
    <metric>blueforagingtime</metric>
    <metric>redage</metric>
    <metric>blueage</metric>
    <enumeratedValueSet variable="murderer">
      <value value="20"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="foodbonus">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="Impact of learning age and foraging time measured, varying m" repetitions="16" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go
if ticks = 10000 [set redfood 0 set bluefood 0]</go>
    <timeLimit steps="16000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <metric>redfoods</metric>
    <metric>bluefoods</metric>
    <metric>redforagingtime</metric>
    <metric>blueforagingtime</metric>
    <metric>redage</metric>
    <metric>blueage</metric>
    <steppedValueSet variable="murderer" first="0" step="10" last="20"/>
    <enumeratedValueSet variable="foodbonus">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="higher m reduces foraging efficency?" repetitions="1" runMetricsEveryStep="true">
    <setup>setup
create-sheep 6
ask patches [set pcolor random 200]</setup>
    <go>go</go>
    <timeLimit steps="2000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <metric>redforagingtime</metric>
    <metric>blueforagingtime</metric>
    <metric>redage</metric>
    <metric>blueage</metric>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <steppedValueSet variable="murderer" first="10" step="30" last="100"/>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="92"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="foodbonus">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="higher m reduces foraging efficency with mortality" repetitions="1" runMetricsEveryStep="true">
    <setup>setup
create-sheep 6</setup>
    <go>go</go>
    <timeLimit steps="5000"/>
    <metric>count rants</metric>
    <metric>count bants</metric>
    <metric>redforagingtime</metric>
    <metric>blueforagingtime</metric>
    <metric>redage</metric>
    <metric>blueage</metric>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <steppedValueSet variable="murderer" first="10" step="30" last="100"/>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="92"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="foodbonus">
      <value value="4"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
  </experiment>
  <experiment name="New Code 2" repetitions="1" runMetricsEveryStep="true">
    <setup>setup
ask patches [set pcolor random 139.9]
create-sheep 10</setup>
    <go>go
if ticks &gt; 200 [ set murderer 5]</go>
    <timeLimit steps="2000"/>
    <metric>count bants</metric>
    <metric>count rants</metric>
    <metric>%redmurderer</metric>
    <metric>redmurders</metric>
    <metric>%bluemurderer</metric>
    <metric>murders</metric>
    <metric>agedeaths</metric>
    <metric>redagedeaths</metric>
    <metric>stdbantfoodpref</metric>
    <metric>stdrantfoodpref</metric>
    <metric>mostavailablefood</metric>
    <metric>rantfoodpreference</metric>
    <metric>bantfoodpreference</metric>
    <metric>redage</metric>
    <metric>blueage</metric>
    <metric>redforagingtime</metric>
    <metric>blueforagingtime</metric>
    <metric>redfoods</metric>
    <metric>bluefoods</metric>
    <enumeratedValueSet variable="murderer">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-chemicals?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="birth-energy">
      <value value="100"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="diffusing">
      <value value="0.11"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementy">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="killer-coefficient">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporation-rate">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="show-energy?">
      <value value="false"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluegression">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="number">
      <value value="200"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="evaporationrate">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Aggression">
      <value value="1"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="season">
      <value value="&quot;summer&quot;"/>
    </enumeratedValueSet>
    <steppedValueSet variable="foodbonus" first="5" step="15" last="105"/>
    <enumeratedValueSet variable="regrowth">
      <value value="28"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="redgress">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="energy-from-grass">
      <value value="10"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="regrow">
      <value value="50"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="movementx">
      <value value="0"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="bluestart">
      <value value="92"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
